Autocomplete
Bootstrap Autocomplete
Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5.
While we'll continue to support for the transition period, we encourage you to migrate to
MDB5. We're offering a huge discount on MDB5 PRO to help with your transition,
enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount
The Bootstrap Autocomplete component predicts the words being typed based on the first few letters given by the user. You can search the list using basic scroll and the keyboard arrows
A basic example MDB Pro component
With our component you can easily add to autocomplete menu what you want.
You only need to add arrays in JavaScript with your variable
and you have to initiate that variable
with our JavaScript code.
For example:
<div class="md-form">
<input type="search" id="form-autocomplete" class="form-control mdb-autocomplete">
<button class="mdb-autocomplete-clear">
<svg fill="#000000" height="24" viewBox="0 0 24 24" width="24" xmlns="https://www.w3.org/2000/svg">
<path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z" />
<path d="M0 0h24v24H0z" fill="none" />
</svg>
</button>
<label for="form-autocomplete" class="active">What is your favorite US state?</label>
</div>
var states = [
"Alabama",
"Alaska",
"Arizona",
"Arkansas",
"California",
"Colorado",
"Connecticut",
"Delaware",
"Florida",
"Georgia",
"Hawaii",
"Idaho",
"Illnois",
"Indiana",
"Iowa",
"Kansas",
"Kentucky",
"Louisiana",
"Maine",
"Maryland",
"Massachusetts",
"Michigan",
"Minnesota",
"Mississippi",
"Missouri",
"Montana",
"Nebraska",
"Nevada",
"New Hampshire",
"New Jersey",
"New Mexico",
"New York",
"North Carolina",
"North Dakota",
"Ohio",
"Oklahoma",
"Oregon",
"Pennsylvania",
"Rhode Island",
"South Carolina",
"South Dakota",
"Tennessee",
"Texas",
"Utah",
"Vermont",
"Virginia",
"Washington",
"West Virginia",
"Wisconsin",
"Wyoming"
];
$('#form-autocomplete').mdbAutocomplete({
data: states
});
Autocomplete within a form MDB Pro component
With MDB Autocomplete you can use forms to implement our practical component.
Check our documentation about forms.
Sign up
or Sign up with:
<section class="form-elegant">
<!-- Grid row -->
<div class="row">
<!-- Grid column -->
<div class="col-md-9 col-lg-7 col-xl-5">
<!--Form without header-->
<div class="card">
<div class="card-body mx-4">
<!--Header-->
<div class="text-center">
<h3 class="dark-grey-text mb-5"><strong>Sign up</strong></h3>
</div>
<!--Body-->
<div class="md-form">
<input type="text" id="Form-email1" class="form-control">
<label for="Form-email1">Your email</label>
</div>
<div class="md-form">
<input type="password" id="Form-pass1" class="form-control">
<label for="Form-pass1">Your password</label>
</div>
<div class="md-form pb-3">
<input type="search" id="form-autocomplete-1" class="form-control mdb-autocomplete">
<button class="mdb-autocomplete-clear">
<svg fill="#000000" height="24" viewBox="0 0 24 24" width="24" xmlns="https://www.w3.org/2000/svg">
<path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z" />
<path d="M0 0h24v24H0z" fill="none" />
</svg>
</button>
<label for="form-autocomplete-1" class="active">Your country</label>
</div>
<div class="text-center mb-3">
<button type="button" class="btn blue-gradient btn-block btn-rounded z-depth-1a">Sign up</button>
</div>
<p class="font-small dark-grey-text text-right d-flex justify-content-center mb-3 pt-2"> or Sign up
with:</p>
<div class="row my-3 d-flex justify-content-center">
<!--Facebook-->
<button type="button" class="btn btn-white btn-rounded mr-md-3 z-depth-1a"><i class="fab fa-facebook-f blue-text text-center"></i></button>
<!--Twitter-->
<button type="button" class="btn btn-white btn-rounded mr-md-3 z-depth-1a"><i class="fab fa-twitter blue-text"></i></button>
<!--Google +-->
<button type="button" class="btn btn-white btn-rounded z-depth-1a"><i class="fab fa-google-plus-g blue-text"></i></button>
</div>
</div>
<!--Footer-->
<div class="modal-footer mx-5 pt-3 mb-1">
<p class="font-small grey-text d-flex justify-content-end">Already a member? <a href="#" class="blue-text ml-1">
Sign In</a></p>
</div>
</div>
<!--/Form without header-->
</div>
<!-- Grid column -->
</div>
<!-- Grid row -->
</section>
.form-elegant .font-small {
font-size: 0.8rem;
}
.form-elegant .z-depth-1a {
-webkit-box-shadow: 0 2px 5px 0 rgba(55, 161, 255, 0.26), 0 4px 12px 0 rgba(121, 155, 254, 0.25);
box-shadow: 0 2px 5px 0 rgba(55, 161, 255, 0.26), 0 4px 12px 0 rgba(121, 155, 254, 0.25);
}
.form-elegant .z-depth-1-half,
.form-elegant .btn:hover {
-webkit-box-shadow: 0 5px 11px 0 rgba(85, 182, 255, 0.28), 0 4px 15px 0 rgba(36, 133, 255, 0.15);
box-shadow: 0 5px 11px 0 rgba(85, 182, 255, 0.28), 0 4px 15px 0 rgba(36, 133, 255, 0.15);
}
var countries = [
"Afghanistan",
"Albania",
"Algeria",
"Andorra",
"Angola",
"Antigua and Barbuda",
"Argentina",
"Armenia",
"Australia",
"Austria",
"Azerbaijan",
"Bahamas",
"Bahrain",
"Bangladesh",
"Barbados",
"Belarus",
"Belgium",
"Belize",
"Benin",
"Bhutan",
"Bolivia",
"Bosnia and Herzegovina",
"Botswana",
"Brazil",
"Brunei",
"Bulgaria",
"Burkina Faso",
"Burundi",
"Cabo Verde",
"Cambodia",
"Cameroon",
"Canada",
"Central African Republic (CAR)",
"Chad",
"Chile",
"China",
"Colombia",
"Comoros",
"Costa Rica",
"Cote d'Ivoire",
"Croatia",
"Cuba",
"Cyprus",
"Czech Republic",
"Denmark",
"Djibouti",
"Dominica",
"Dominican Republic",
"Ecuador",
"Egypt",
"El Salvador",
"Equatorial Guinea",
"Eritrea",
"Estonia",
"Ethiopia",
"Fiji",
"Finland",
"France",
"Gabon",
"Gambia",
"Georgia",
"Germany",
"Ghana",
"Greece",
"Grenada",
"Guatemala",
"Guinea",
"Guinea-Bissau",
"Guyana",
"Haiti",
"Honduras",
"Hungary",
"Iceland",
"India",
"Indonesia",
"Iran",
"Iraq",
"Ireland",
"Israel",
"Italy",
"Jamaica",
"Japan",
"Jordan",
"Kazakhstan",
"Kenya",
"Kiribati",
"Kosovo",
"Kuwait",
"Kyrgyzstan",
"Laos",
"Latvia",
"Lebanon",
"Lesotho",
"Liberia",
"Libya",
"Liechtenstein",
"Lithuania",
"Luxembourg",
"Macedonia (FYROM)",
"Madagascar",
"Malawi",
"Malaysia",
"Maldives",
"Mali",
"Malta",
"Marshall Islands",
"Mauritania",
"Mauritius",
"Mexico",
"Micronesia",
"Moldova",
"Monaco",
"Mongolia",
"Montenegro",
"Morocco",
"Mozambique",
"Myanmar (Burma)",
"Namibia",
"Nauru",
"Nepal",
"Netherlands",
"New Zealand",
"Nicaragua",
"Niger",
"Nigeria",
"North Korea",
"Norway",
"Oman",
"Pakistan",
"Palau",
"Palestine",
"Panama",
"Papua New Guinea",
"Paraguay",
"Peru",
"Philippines",
"Poland",
"Portugal",
"Qatar",
"Romania",
"Russia",
"Rwanda",
"Saint Kitts and Nevis",
"Saint Lucia",
"Saint Vincent and the Grenadines",
"Samoa",
"San Marino",
"Sao Tome and Principe",
"Saudi Arabia",
"Senegal",
"Serbia",
"Seychelles",
"Sierra Leone",
"Singapore",
"Slovakia",
"Slovenia",
"Solomon Islands",
"Somalia",
"South Africa",
"South Korea",
"South Sudan",
"Spain",
"Sri Lanka",
"Sudan",
"Suriname",
"Swaziland",
"Sweden",
"Switzerland",
"Syria",
"Taiwan",
"Tajikistan",
"Tanzania",
"Thailand",
"Timor-Leste",
"Togo",
"Tonga",
"Trinidad and Tobago",
"Tunisia",
"Turkey",
"Turkmenistan",
"Tuvalu",
"Uganda",
"Ukraine",
"United Arab Emirates (UAE)",
"United Kingdom (UK)",
"United States of America (USA)",
"Uruguay",
"Uzbekistan",
"Vanuatu",
"Vatican City (Holy See)",
"Venezuela",
"Vietnam",
"Yemen",
"Zambia",
"Zimbabwe"
];
$('#form-autocomplete-1').mdbAutocomplete({
data: countries
});
Autocomplete within a modal box MDB Pro component
You can also easily use MDB autocomplete with modals.
You can show modal with our component to make your website more attractive. Chek our documentation abouts modals.
For example:
<div class="modal fade" id="modalContactForm" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
aria-hidden="true">
<div class="modal-dialog cascading-modal" role="document">
<!--Content-->
<div class="modal-content">
<!--Header-->
<div class="modal-header light-blue darken-3 white-text">
<h4 class="title"><i class="fas fa-pencil-alt"></i> Contact form</h4>
<button type="button" class="close waves-effect waves-light" data-dismiss="modal" aria-label="Close">
<span aria-hidden="true">×</span>
</button>
</div>
<!--Body-->
<div class="modal-body mb-0">
<div class="md-form form-sm">
<i class="fas fa-envelope prefix active"></i>
<input type="text" id="form8" class="form-control">
<label for="form8" class="active">Your name</label>
</div>
<div class="md-form form-sm">
<i class="fas fa-lock prefix active"></i>
<input type="password" id="form9" class="form-control">
<label for="form9" class="active">Your email</label>
</div>
<div class="md-form form-sm">
<i class="fas fa-tag prefix"></i>
<input type="search" id="form-autocomplete-2" class="form-control mdb-autocomplete">
<button class="mdb-autocomplete-clear">
<svg fill="#000000" height="24" viewBox="0 0 24 24" width="24" xmlns="https://www.w3.org/2000/svg">
<path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z" />
<path d="M0 0h24v24H0z" fill="none" />
</svg>
</button>
<label for="form-autocomplete-2" class="active">Subject</label>
</div>
<div class="md-form form-sm">
<i class="fas fa-pencil-alt prefix"></i>
<textarea type="text" id="form67" class="md-textarea mb-0"></textarea>
<label for="form67">Your message</label>
</div>
<div class="text-center mt-1-half">
<button class="btn btn-info mb-2 waves-effect waves-light">Send <i class="fas fa-send ml-1"></i></button>
</div>
</div>
</div>
<!--/.Content-->
</div>
</div>
<div class="text-center">
<a href="" class="btn btn-default btn-rounded my-3" data-toggle="modal" data-target="#modalContactForm">Launch
Modal Contact</a>
</div>
var subjects = [
"Where's My Stuff?",
"Cancel Items or Orders",
"Returns & Refunds",
"Shipping Rates & Information",
"Change Your Payment Method",
"Manage Your Account Information",
"About Two-Step Verification",
"Cancel Items or Orders",
"Change Your Order Information",
"Contact Third-Party Sellers",
"More in Managing Your Orders"
];
$('#form-autocomplete-2').mdbAutocomplete({
data: subjects
});
JavaScript options
Option can be passed via JavaScript.
Name | Type | Default | Description |
---|---|---|---|
data | array | [] | Apply a data in a array. |
dataColor | color | '' | Change color of data items |
inputFocus | color | 1px solid #4285f4 | Change color of input when is focusing |
inputBlur | color | 1px solid #ced4da | Change blur color of input |
inputFocusShadow | color | 0 1px 0 0 #4285f4 | Change shadow color of input |
inputBlurShadow | color | '' | Change blur shadow color of input |
visibleOptions | number | 5 | Change the number of visible options |
Options example
<div class="md-form">
<input type="search" id="form-autocomplete-4" class="form-control mdb-autocomplete">
<button class="mdb-autocomplete-clear">
<svg fill="#000000" height="24" viewBox="0 0 24 24" width="24" xmlns="https://www.w3.org/2000/svg">
<path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z" />
<path d="M0 0h24v24H0z" fill="none" />
</svg>
</button>
<label for="form-autocomplete-4" class="active">What is your favorite US state?</label>
</div>
let states = [
"Alabama",
"Alaska",
"Arizona",
"Arkansas",
"California",
"Colorado",
"Connecticut",
"Delaware",
"Florida",
"Georgia",
"Hawaii",
"Idaho",
"Illnois",
"Indiana",
"Iowa",
"Kansas",
"Kentucky",
"Louisiana",
"Maine",
"Maryland",
"Massachusetts",
"Michigan",
"Minnesota",
"Mississippi",
"Missouri",
"Montana",
"Nebraska",
"Nevada",
"New Hampshire",
"New Jersey",
"New Mexico",
"New York",
"North Carolina",
"North Dakota",
"Ohio",
"Oklahoma",
"Oregon",
"Pennsylvania",
"Rhode Island",
"South Carolina",
"South Dakota",
"Tennessee",
"Texas",
"Utah",
"Vermont",
"Virginia",
"Washington",
"West Virginia",
"Wisconsin",
"Wyoming"
];
$('#form-autocomplete-4').mdbAutocomplete({
data: states,
dataColor: 'green',
inputFocus: '2px solid green',
inputBlur: '1px solid #ced4da',
inputFocusShadow: '0 1px 0 0 #4285f4',
inputBlurShadow: ''
});

Angular Bootstrap Autocomplete

Angular Autocomplete - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Angular Bootstrap autocomplete is a component that predicts the words based on the first few letters given by a user, while they are typing it.

Warning notification

In the MDB Angular 7.2.0 version, the mdb-autocomplete component was changed to mdb-auto-completer. Its construction is completely different. The following documentation presents the new version of this component. If you are still using the old version, its documentation can be found here. In MDB Angular 8 we will remove the old version of mdb-autocomplete, so we recommend that you migrate to the new version as soon as possible.


Basic example MDB Pro component

        
            
            <div class="md-form">
              <input
                type="text"
                class="completer-input form-control mdb-autocomplete"
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutoCompleter]="auto"
                placeholder="Choose your color"
              />
              <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';

            @Component({
              selector: 'basic-auto-completer',
              templateUrl: './basic-auto-completer.component.html',
              styleUrls: ['./basic-auto-completer.component.scss'],
            })
            export class BasicAutoCompleterComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;

              data: any = [
                'red',
                'green',
                'blue',
                'cyan',
                'magenta',
                'yellow',
                'black',
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value))
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Disabled autocomplete MDB Pro component

Use the disabled attribute on the input element, and [disabled]="true" on the mdb-auto-completer element to disable the whole autocompleter component.

        
            
            <div class="md-form">
              <input
                disabled
                type="text"
                class="completer-input form-control mdb-autocomplete"
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutoCompleter]="auto"
                placeholder="Choose your color"
              />
              <mdb-auto-completer [disabled]="true" #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';

            @Component({
              selector: 'basic-auto-completer',
              templateUrl: './basic-auto-completer.component.html',
              styleUrls: ['./basic-auto-completer.component.scss'],
            })
            export class BasicAutoCompleterComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;

              data: any = [
                'red',
                'green',
                'blue',
                'cyan',
                'magenta',
                'yellow',
                'black',
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value))
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Remote data MDB Pro component

        
            
            <div class="md-form">
              <input
                type="text"
                class="completer-input form-control mdb-autocomplete mb-0"
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutoCompleter]="auto"
                placeholder="Pick the Star Wars character"
              />
              <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                <mdb-option *ngFor="let option of results | async" [value]="option.name">
                  <div class="d-flex flex-column">
                    <strong>Name: {{ option.name }}</strong>
                    <small>Gender: {{ option.gender }}</small>
                    <small>Hair color: {{ option.hair_color }}</small>
                  </div>
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { HttpClient } from '@angular/common/http';
            import { map } from 'rxjs/operators';

            @Component({
              selector: 'remote-auto-completer',
              templateUrl: './remote-auto-completer.component.html',
              styleUrls: ['./remote-auto-completer.component.scss'],
            })
            export class RemoteAutoCompleterComponent {
              searchText = new Subject<string>();
              url = 'https://swapi.py4e.com/api/people/?search=';
              results: Observable<any>;
              data: any = [];

              constructor(private httpClient: HttpClient) {
                this.httpClient.get(this.url).subscribe((data: any) => {
                  console.log(data);
                  this.data = data;
                  this.results = this.searchText.pipe(
                    startWith(''),
                    map((value: string) => this.filter(value))
                  );
                });
              }

              filter(value: string): string[] | undefined {
                const filterValue = value.toLowerCase();
                if (this.data && this.data['results']) {
                  return this.data['results'].filter((item: any) =>
                    item.name.toLowerCase().includes(filterValue)
                  );
                }
              }
            }
          
        
    

Reactive forms MDB Pro component

In this section, you will find information on how to use our autocomplete component in reactive forms.

Remember to import ReactiveFormsModule into your app.module.ts

Default value

Set default value in FormControl

        
            
            <form [formGroup]="testForm">
              <div class="md-form">
                <input
                  formControlName="testAutocomplete"
                  type="text"
                  class="completer-input form-control mdb-autocomplete mb-0"
                  [mdbAutoCompleter]="auto"
                  placeholder="Choose your color"
                />
                <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                  <mdb-option *ngFor="let option of results | async" [value]="option">
                    {{ option }}
                  </mdb-option>
                </mdb-auto-completer>
              </div>
            </form>
          
        
    
        
            
            import { OnInit, Component } from '@angular/core';
            import { FormControl, FormGroup } from '@angular/forms';
            import { Observable } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';

            @Component({
              selector: 'reactive-form-auto-completer',
              templateUrl: './reactive-form-auto-completer.component.html',
              styleUrls: ['./reactive-form-auto-completer.component.scss'],
            })
            export class ReactiveFormAutoCompleterComponent {
              results: Observable<string[]>;
              data: any = ['red', 'green', 'blue', 'cyan', 'magenta', 'yellow', 'black'];
              testForm: FormGroup;

              constructor() {
                this.testForm = new FormGroup({
                  testAutocomplete: new FormControl('red')
                });
                this.results = this.testForm.controls.testAutocomplete.valueChanges
                  .pipe(
                    startWith('red'),
                    map((value: string) => this.filter(value))
                  );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: any) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Append to body MDB Pro component

In this section, you will find information on how to append mdb-auto-completer component to the body element.

        
            
            <div class="md-form">
              <input
                type="text"
                class="completer-input form-control mdb-autocomplete"
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutoCompleter]="auto"
                placeholder="Choose your color"
              />
              <mdb-auto-completer [appendToBody]="true" #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';

            @Component({
              selector: 'body-auto-completer',
              templateUrl: './body-auto-completer.component.html',
              styleUrls: ['./body-auto-completer.component.scss'],
            })
            export class BodyAutoCompleterComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;

              data: any = [
                'red',
                'green',
                'blue',
                'cyan',
                'magenta',
                'yellow',
                'black',
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value))
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Visible Options MDB Pro component

In this section, you will find information on how to set visibleOptions and optionHeight options to the autocomplete component.

        
            
            <div class="md-form">
              <input
                type="text"
                class="completer-input form-control mdb-autocomplete"
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutoCompleter]="auto"
                placeholder="Choose your color"
              />
              <mdb-auto-completer
                [visibleOptions]="5"
                [optionHeight]="40"
                #auto="mdbAutoCompleter" textNoResults="I have found no results :("
              >
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';

            @Component({
              selector: 'body-auto-completer',
              templateUrl: './body-auto-completer.component.html',
              styleUrls: ['./body-auto-completer.component.scss'],
            })
            export class BodyAutoCompleterComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;

              data: any = [
                'red',
                'green',
                'blue',
                'cyan',
                'magenta',
                'yellow',
                'black',
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value))
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Display Value MDB Pro component

In this section, you will find information on how to set different option's control value than the option's display value (what is displayed in the text field).

        
            
            <div class="md-form">
              <input
                type="text"
                class="completer-input form-control mdb-autocomplete"
                [formControl]="myControl"
                [mdbAutoCompleter]="auto"
                placeholder="Choose your color"
              />
              <mdb-auto-completer
              [displayValue]="onDisplayValue"
              #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                <mdb-option *ngFor="let option of data | async" [value]="option">
                  {{ option.name }}
                </mdb-option>
              </mdb-auto-completer>
            </div>
          
        
    
        
            
            import { Component,  OnInit} from '@angular/core';
            import { Observable } from 'rxjs';
            import { startWith, map } from 'rxjs/operators';
            import { FormControl } from '@angular/forms';

            export interface Color {
              name: string;
            }

            @Component({
              selector: 'body-auto-completer',
              templateUrl: './body-auto-completer.component.html',
              styleUrls: ['./body-auto-completer.component.scss'],
            })
            export class BodyAutoCompleterComponent {
              myControl = new FormControl();

              options: Color[] = [
                {name: 'red'},
                {name: 'green'},
                {name: 'blue'}
              ];

              data: Observable<Color[]>;

              constructor() {
                this.data = this.myControl.valueChanges
                .pipe(
                  startWith(''),
                  map(value => typeof value === 'string' ? value : value.name),
                  map(name => name ? this.filter(name) : this.options.slice())
                );
              }

              onDisplayValue(color: Color): string | undefined {
                console.log(color)
                return color ? color.name : undefined;
              }

              filter(name: string): Color[] {
                const filterValue = name.toLowerCase();
                return this.options.filter(option => option.name.toLowerCase().indexOf(filterValue) === 0);
              }
            }
          
        
    

Angular Autocomplete - API

In this section you will find informations about required modules and available inputs, outputs, methods and events of autocomplete component.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

        
            
          import { AutoCompleterModule, InputsModule } from 'ng-uikit-pro-standard';
          import { FormsModule } from '@angular/forms';
        
        
    

Components

MdbAutoCompleterComponent

Selector: mdb-auto-completer

Type: MdbAutoCompleterComponent

MdbOptionComponent

Selector: mdb-option

Type: MdbOptionComponent


Directives

MdbAutoCompleterDirective

Selector: mdbAutoCompleter

Type: MdbAutoCompleterDirective

Export as: mdbAutoCompleterTrigger


Inputs

MdbAutoCompleterComponent
Name Type Default Description Example
textNoResults string - Changes no results text textNoResults="Custom text"
clearButton boolean true Shows the clear button [clearButton]="true"
clearButtonTabIndex number 0 Set the clear button tab index [clearButtonTabIndex]="1"
disabled boolean false Disable the mdb-auto-completer component [disabled]="true"
appendToBody boolean false If true, will append the mdb-auto-completer dropdown element to the body element. Helpful when mdb-auto-completer parent has a overflow: hidden [appendToBody]="true"
visibleOptions number 4 Changes visible options in autocomplete dropdown [visibleOptions]="5"
optionHeight number 45 Changes height of each option (in pixels) [optionHeight]="40"
displayValue function - Set display value to different than control value. [displayValue]="onDisplayValue"
MdbOptionComponent
Name Type Default Description Example
value string - Option component value [value]="value"
MdbAutoCompleterDirective
Name Type Default Description Example
mdbAutoCompleter MdbAutoCompleterComponent - Auto Completer component binding [mdbAutoCompleter]="autocomplete"

Outputs

MdbAutoCompleterComponent
Name Type Description Example
select EventEmitter<any> Event emitted when item is selected (highlighted) (select)="onItemSelect($event)"
selected EventEmitter<any> Event emitted when new item is selected (picked from the list) (selected)="onItemSelect($event)"
MdbAutoCompleterDirective
Name Type Description Example
clearBtnClicked EventEmitter<any> Event emitted when clear button is clicked (clearBtnClicked)="onClearButtonClick()"

Methods

You can get access to public methods of the directives from another component

@ViewChild(MdbAutoCompleterDirective, { static: true }) mdbAutoCompleter: MdbAutoCompleterDirective;

MdbAutoCompleterDirective
Name Description
clear() Clears the input value

Angular Autocomplete - examples & customization


Autocomplete with icons MDB Pro component

        
            
          <div class="md-form">
            <input
              type="text"
              [ngModel]="searchText | async"
              (ngModelChange)="searchText.next($event)"
              class="completer-input form-control mdb-autocomplete mb-0"
              [mdbAutoCompleter]="auto"
              placeholder="Choose your color"
            />
            <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
              <mdb-option *ngFor="let option of results | async" [value]="option.name">
                <div class="d-flex justify-content-between align-items-center w-100">
                  <span>{{ option.name }}</span>
                  <img [src]="option.icon" alt="{{ option.name }} photo" class="completer-image" />
                </div>
              </mdb-option>
            </mdb-auto-completer>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';
          import { Observable, Subject } from 'rxjs';
          import { startWith, map } from 'rxjs/operators';

          @Component({
            selector: 'auto-completer-with-icons',
            templateUrl: './auto-completer-with-icon.component.html',
            styleUrls: ['./auto-completer-with-icon.component.scss'],
          })
          export class AutoCompleterWithIconsComponent {
            searchText = new Subject<string>();
            results: Observable<any>;

            data: any[] = [
              { name: 'Anthony', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp' },
              { name: 'Jane', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp' },
              { name: 'John', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-8.webp' },
              { name: 'Samantha', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-4.webp' }
            ];

            constructor() {
              this.results = this.searchText
                .pipe(
                  startWith(''),
                  map((value: string) => this.filter(value))
                );
            }

            filter(value: string): string[] {
              const filterValue = value.toLowerCase();
              return this.data.filter((item: any) => item.name.toLowerCase().includes(filterValue));
            }
          }
        }
        
        
    

Second dependent on the first MDB Pro component

The selection of values in the first auto-completer determines the options to choose in the second auto-completer.

        
            
          <div class="row">
            <div class="col-md-4 mx-auto-my-5">
              <div class="md-form">
                <input
                  type="text"
                  [ngModel]="searchText | async"
                  (ngModelChange)="searchText.next($event)"
                  class="completer-input form-control mdb-autocomplete mb-0"
                  [mdbAutoCompleter]="auto"
                  placeholder="Choose your color"
                />
                <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
                  <mdb-option *ngFor="let option of results | async" [value]="option">
                    <div class="d-flex flex-column">
                      {{ option }}
                    </div>
                  </mdb-option>
                </mdb-auto-completer>
              </div>
            </div>

            <div class="col-md-4 mx-auto-my-5">
              <div class="md-form">
                <input
                  type="text"
                  [ngModel]="searchText2 | async"
                  (ngModelChange)="searchText2.next($event)"
                  class="completer-input form-control mdb-autocomplete mb-0"
                  [mdbAutoCompleter]="auto2"
                  placeholder="Choose your color"
                />
                <mdb-auto-completer #auto2="mdbAutoCompleter" textNoResults="I have found no results :(">
                  <mdb-option *ngFor="let option of results2 | async" [value]="option">
                    <div class="d-flex flex-column">
                      {{ option }}
                    </div>
                  </mdb-option>
                </mdb-auto-completer>
              </div>
            </div>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';
          import { Observable, Subject } from 'rxjs';
          import { startWith, map, tap } from 'rxjs/operators';

          @Component({
            selector: 'multiple-autocompleter',
            templateUrl: './multiple-autocompleter.component.html',
            styleUrls: ['./multiple-autocompleter.component.scss'],
          })
          export class MultipleAutoCompleterComponent {
            searchText = new Subject<string>();
            searchText2 = new Subject<string>();
            results: Observable<string[]>;
            results2: Observable<string[]>;

            data: string[] = ['Angular', 'React', 'Vue', 'jQuery'];

            data2: string[] = [];

            constructor() {
              this.results = this.searchText
                .pipe(
                  startWith(''),
                  tap((searchText: string) => this.updateSecondCompleterData(searchText)),
                  map((value: string) => this.filter(value, this.data))
                );

              this.results2 = this.searchText2
                .pipe(
                  startWith(''),
                  map((value: string) => this.filter(value, this.data2))
                );
            }

            updateSecondCompleterData(searchText: string) {
              if (searchText === 'Angular') {
                this.data2 = ['Angular 1', 'Angular 2', 'Angular 3', 'Angular 4'];
              } else if (searchText === 'React') {
                this.data2 = ['React 1', 'React 2', 'React 3', 'React 4'];
              } else if (searchText === 'Vue') {
                this.data2 = ['Vue 1', 'Vue 2', 'Vue 3', 'Vue 4'];
              } else if (searchText === 'jQuery') {
                this.data2 = ['jQuery 1', 'jQuery 2', 'jQuery 3', 'jQuery 4'];
              }
            }

            filter(value: string, data: string[]): string[] {
              const filterValue = value.toLowerCase();
              return data.filter((item: string) => item.toLowerCase().includes(filterValue));
            }
          }
        
        
    

Remote call after input event MDB Pro component

The selection of values in the first auto-completer determines the options to choose in the second auto-completer.

        
            
          <div class="md-form">
            <input
              type="text"
              [ngModel]="searchText | async"
              (ngModelChange)="searchText.next($event)"
              class="completer-input form-control mdb-autocomplete mb-0"
              [mdbAutoCompleter]="auto"
              placeholder="Choose your color"
            />
            <mdb-auto-completer #auto="mdbAutoCompleter" textNoResults="I have found no results :(">
              <mdb-option *ngFor="let option of results | async" [value]="option.name">
                <div class="d-flex flex-column">
                  <strong>Name: {{ option.name }}</strong>
                  <small>Gender: {{ option.gender }}</small>
                  <small>Hair color: {{ option.hair_color }}</small>
                </div>
              </mdb-option>
            </mdb-auto-completer>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';
          import { Observable, Subject } from 'rxjs';
          import { startWith, map, debounceTime, switchMap } from 'rxjs/operators';
          import { HttpClient } from '@angular/common/http';

          @Component({
            selector: 'remote-event',
            templateUrl: './remote-event.component.html',
            styleUrls: ['./remote-event.component.scss']
          })
          export class RemoteEventComponent {
            searchText = new Subject<string>();
            results: Observable<any>;
            url = 'https://swapi.py4e.com/api/people/?search=';

            constructor(private http: HttpClient) {
              this.results = this.searchText
              .pipe(
                startWith(this.searchText),
                switchMap((searchText: string) => this.getRemoteData(searchText))
              );
            }

            getRemoteData(searchText: string) {
              return this.http.get(this.url + searchText)
                .pipe(
                  debounceTime(250),
                  map((items: any) => items.results)
                );
            }
          }

React Bootstrap Autocomplete

React Autocomplete - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap Autocomplete is a component which predicts the words basing on the first few letters given by a user, while one is typing it. It takes in an Array full of suggestions.

You can use and arrow keys to navigate through options and use key to select required option.

Live example

Note info: If you want to use new version of Autocomplete please see our API docs which is available above in the tab section.
You can see a live example of MDBAutocompleteV5 here.


Basic example

        
            
                  import React, { Component } from "react";
                  import { MDBContainer, MDBAutocomplete } from "mdbreact";
  
                  const states = [
                    "Alabama",
                    "Alaska",
                    "Arizona",
                    "Arkansas",
                    "California",
                    "Colorado",
                    "Connecticut",
                    "Delaware",
                    "Florida",
                    "Georgia",
                    "Hawaii",
                    "Idaho",
                    "Illnois",
                    "Indiana",
                    "Iowa",
                    "Kansas",
                    "Kentucky",
                    "Louisiana",
                    "Maine",
                    "Maryland",
                    "Massachusetts",
                    "Michigan",
                    "Minnesota",
                    "Mississippi",
                    "Missouri",
                    "Montana",
                    "Nebraska",
                    "Nevada",
                    "New Hampshire",
                    "New Jersey",
                    "New Mexico",
                    "New York",
                    "North Carolina",
                    "North Dakota",
                    "Ohio",
                    "Oklahoma",
                    "Oregon",
                    "Pennsylvania",
                    "Rhode Island",
                    "South Carolina",
                    "South Dakota",
                    "Tennessee",
                    "Texas",
                    "Utah",
                    "Vermont",
                    "Virginia",
                    "Washington",
                    "West Virginia",
                    "Wisconsin",
                    "Wyoming"
                  ];
  
                  class AutocompletePage extends Component {
  
                    logValue = value => {
                      console.log(value);
                    };
                    render() {
                      return (
                        <MDBContainer>
                          <MDBAutocomplete
                            data={states}
                            label="Choose your favorite state"
                            icon="heart"
                            clear
                            id="input"
                            getValue={this.logValue}
                          />
                        </MDBContainer>
                      );
                    }
                  }
  
                  export default AutocompletePage;
              
        
    

Autocomplete within form

Sign up

or Sign up with:

        
            
                  import React from 'react';
                  import {
                    MDBAutocomplete,
                    MDBRow,
                    MDBCol,
                    MDBInput,
                    MDBBtn,
                    MDBCard,
                    MDBCardBody,
                    MDBModalFooter,
                    MDBIcon
                  } from 'mdbreact';
  
                  const countries = [
                    "Afghanistan",
                    "Albania",
                    "Algeria",
                    "Andorra",
                    "Angola",
                    "Antigua and Barbuda",
                    "Argentina",
                    "Armenia",
                    "Australia",
                    "Austria",
                    "Azerbaijan",
                    "Bahamas",
                    "Bahrain",
                    "Bangladesh",
                    "Barbados",
                    "Belarus",
                    "Belgium",
                    "Belize",
                    "Benin",
                    "Bhutan",
                    "Bolivia",
                    "Bosnia and Herzegovina",
                    "Botswana",
                    "Brazil",
                    "Brunei",
                    "Bulgaria",
                    "Burkina Faso",
                    "Burundi",
                    "Cabo Verde",
                    "Cambodia",
                    "Cameroon",
                    "Canada",
                    "Central African Republic (CAR)",
                    "Chad",
                    "Chile",
                    "China",
                    "Colombia",
                    "Comoros",
                    "Costa Rica",
                    "Cote d'Ivoire",
                    "Croatia",
                    "Cuba",
                    "Cyprus",
                    "Czech Republic",
                    "Denmark",
                    "Djibouti",
                    "Dominica",
                    "Dominican Republic",
                    "Ecuador",
                    "Egypt",
                    "El Salvador",
                    "Equatorial Guinea",
                    "Eritrea",
                    "Estonia",
                    "Ethiopia",
                    "Fiji",
                    "Finland",
                    "France",
                    "Gabon",
                    "Gambia",
                    "Georgia",
                    "Germany",
                    "Ghana",
                    "Greece",
                    "Grenada",
                    "Guatemala",
                    "Guinea",
                    "Guinea-Bissau",
                    "Guyana",
                    "Haiti",
                    "Honduras",
                    "Hungary",
                    "Iceland",
                    "India",
                    "Indonesia",
                    "Iran",
                    "Iraq",
                    "Ireland",
                    "Israel",
                    "Italy",
                    "Jamaica",
                    "Japan",
                    "Jordan",
                    "Kazakhstan",
                    "Kenya",
                    "Kiribati",
                    "Kosovo",
                    "Kuwait",
                    "Kyrgyzstan",
                    "Laos",
                    "Latvia",
                    "Lebanon",
                    "Lesotho",
                    "Liberia",
                    "Libya",
                    "Liechtenstein",
                    "Lithuania",
                    "Luxembourg",
                    "Macedonia (FYROM)",
                    "Madagascar",
                    "Malawi",
                    "Malaysia",
                    "Maldives",
                    "Mali",
                    "Malta",
                    "Marshall Islands",
                    "Mauritania",
                    "Mauritius",
                    "Mexico",
                    "Micronesia",
                    "Moldova",
                    "Monaco",
                    "Mongolia",
                    "Montenegro",
                    "Morocco",
                    "Mozambique",
                    "Myanmar (Burma)",
                    "Namibia",
                    "Nauru",
                    "Nepal",
                    "Netherlands",
                    "New Zealand",
                    "Nicaragua",
                    "Niger",
                    "Nigeria",
                    "North Korea",
                    "Norway",
                    "Oman",
                    "Pakistan",
                    "Palau",
                    "Palestine",
                    "Panama",
                    "Papua New Guinea",
                    "Paraguay",
                    "Peru",
                    "Philippines",
                    "Poland",
                    "Portugal",
                    "Qatar",
                    "Romania",
                    "Russia",
                    "Rwanda",
                    "Saint Kitts and Nevis",
                    "Saint Lucia",
                    "Saint Vincent and the Grenadines",
                    "Samoa",
                    "San Marino",
                    "Sao Tome and Principe",
                    "Saudi Arabia",
                    "Senegal",
                    "Serbia",
                    "Seychelles",
                    "Sierra Leone",
                    "Singapore",
                    "Slovakia",
                    "Slovenia",
                    "Solomon Islands",
                    "Somalia",
                    "South Africa",
                    "South Korea",
                    "South Sudan",
                    "Spain",
                    "Sri Lanka",
                    "Sudan",
                    "Suriname",
                    "Swaziland",
                    "Sweden",
                    "Switzerland",
                    "Syria",
                    "Taiwan",
                    "Tajikistan",
                    "Tanzania",
                    "Thailand",
                    "Timor-Leste",
                    "Togo",
                    "Tonga",
                    "Trinidad and Tobago",
                    "Tunisia",
                    "Turkey",
                    "Turkmenistan",
                    "Tuvalu",
                    "Uganda",
                    "Ukraine",
                    "United Arab Emirates (UAE)",
                    "United Kingdom (UK)",
                    "United States of America (USA)",
                    "Uruguay",
                    "Uzbekistan",
                    "Vanuatu",
                    "Vatican City (Holy See)",
                    "Venezuela",
                    "Vietnam",
                    "Yemen",
                    "Zambia",
                    "Zimbabwe"
                  ];
  
                  class AutocompleteExample extends React.Component {
  
                    render() {
                      const smallStyle = { fontSize: '0.8rem'}
                      return (
                          <MDBRow>
                            <MDBCol md="9" lg="7" xl="5" className="mx-auto mt-3">
                              <MDBCard>
                                <MDBCardBody className="mx-4">
                                  <div className="text-center">
                                    <h3 className="dark-grey-text mb-5"><strong>Sign in</strong></h3>
                                  </div>
                                  <MDBInput label="Your email" group type="email" validate error="wrong" success="right"/>
                                  <MDBInput label="Your password" group type="password" validate containerClass="mb-0"/>
                                  <MDBAutocomplete label="Your country" clear data={countries}/>
                                  <div className="text-center pt-3 mb-3">
                                    <MDBBtn type="button" gradient="blue" rounded className="btn-block z-depth-1a">Sign in</MDBBtn>
                                  </div>
                                  <p className="dark-grey-text text-right d-flex justify-content-center mb-3 pt-2" style={smallStyle}> or Sign up with:</p>
                                  <div className="row my-3 d-flex justify-content-center">
                                    <MDBBtn type="button" color="white" rounded className="mr-md-3 z-depth-1a"><MDBIcon fab icon="facebook-f" className="blue-text text-center" /></MDBBtn>
                                    <MDBBtn type="button" color="white" rounded className="mr-md-3 z-depth-1a"><MDBIcon fab icon="twitter" className="blue-text" /></MDBBtn>
                                    <MDBBtn type="button" color="white" rounded className="z-depth-1a"><MDBIcon fab icon="google-plus-g" className="blue-text" /></MDBBtn>
                                  </div>
                                </MDBCardBody>
                                <MDBModalFooter className="mx-5 pt-3 mb-1">
                                  <p className="grey-text d-flex justify-content-end" style={smallStyle}>Already a member? <a href="#!" className="blue-text ml-1"> Sign In</a></p>
                                </MDBModalFooter>
                              </MDBCard>
                            </MDBCol>
                          </MDBRow>
                      );
                    }
                  }
  
                  export default AutocompleteExample;
              
        
    

React Autocomplete - API

In this section you will find advanced information about the Autocomplete component. You will find out which modules are required, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Autocomplete import statement

In order to use Autocomplete component make sure you have imported proper module first.

        
            
          import { MDBAutocomplete } from "mdbreact";
        
        
    

New version of Autocomplete what will have a major release in the future and will replace current version. You can easily use it now.

        
            
          import { MDBAutocompleteV5 } from "mdbreact";
          import { MDBAutoV5 } from "mdbreact";
        
        
    

The table below shows the configuration options of the MDBAutocomplete component.

Name Type Default Description Example
className String Adds custom classes <MDBAutocomplete className="myClass" />
clear Boolean true Switch on/off clear button <MDBAutocomplete clear={false} />
clearClass String Adds custom classes to clear button <MDBAutocomplete clearClass="myClass" />
clearSize String Adds custom size to clear button <MDBAutocomplete clearSize="24" />
clearColor String Adds custom color to clear button <MDBAutocomplete clearColor="#a6a6a6" />
data Array[String] Required! Array of options used to autocomplete input <MDBAutocomplete data={["red", "green", "blue"]} />
disabled Boolean false Disables component <MDBAutocomplete disabled />
id String Sets component ID <MDBAutocomplete id="myId" />
label String Sets label for Autocomplete input <MDBAutocomplete label="Choose your favorite state" />
labelClass String Adds custom classes to label <MDBAutocomplete labelClass="myClass" />
icon String Adds font-awesome icon <MDBAutocomplete icon="caret-right" />
iconBrand Boolean false Use this property to set brand icon (fab) <MDBAutocomplete icon="twitter" iconBrand />
iconClass String Adds custom classes to icon element <MDBAutocomplete icon="envelope" iconClass="customClass" />
iconLight Boolean false Use this property to set light icon (fal) <MDBAutocomplete icon="twitter" iconLight />
iconRegular Boolean false Use this property to set regular icon (far) <MDBAutocomplete icon="twitter" iconRegular />
iconSize String Sets icon size <MDBAutocomplete icon="pencil-alt" size="5x" />
placeholder String Adds placeholder text <MDBAutocomplete placeholder="Choose your favorite state" />
valueDefault String Sets default value of the autocomplete input <MDBAutocomplete valueDefault="Default" />

The table below shows the configuration options of the new MDBAutocompleteV5 component which will replace a current version of Autocomplete in the future.

Name Type Default Description Example
className String Adds custom classes <MDBAutocompleteV5 className="myClass" />
clear Boolean true Switch on/off clear button <MDBAutocompleteV5 clear={false} />
clearClass String Adds custom classes to clear button <MDBAutocompleteV5 clearClass="myClass" />
data Array[String] or Object Required! Array or object of options used to autocomplete input <MDBAutocompleteV5 data={["red", "green", "blue"]} />
<MDBAutocompleteV5 data={ data={[ { title: 'The Shawshank Redemption', year: 1994 }, { title: 'The Godfather', year: 1972 }]} />
dataKey String Required! If you are using a object you have to set key to display data from object <MDBAutocompleteV5 data={[ { title: 'The Shawshank Redemption', year: 1994 }, { title: 'The Godfather', year: 1972 }, { title: 'The Godfather: Part II', year: 1974 }, { title: 'The Dark Knight', year: 2008 }, { title: '12 Angry Men', year: 1957 }, { title: "Schindler's List", year: 1993 }]} dataKey="title" />
disabled Boolean false Disables component <MDBAutocompleteV5 disabled />
focused Boolean true Focus Autocomplete onClick/onFocus <MDBAutocompleteV5 focused />
heightItem Number or String 45 Set height to the each element on the list <MDBAutocompleteV5 heightItem={45} />
highlight Boolean false Set highlight of element in the list <MDBAutocompleteV5 highlight />
highlightBold Boolean false Set highlight bold to elements in the list <MDBAutocompleteV5 highlightBold />
highlightStyles Object false Set custom highlight styles to elements in the list <MDBAutocompleteV5 highlightStyles={{color: 'red'}} />
icon String Adds font-awesome icon <MDBAutocompleteV5 icon="caret-right" />
iconBrand Boolean false Use this property to set brand icon (fab) <MDBAutocompleteV5 icon="twitter" iconBrand />
iconClass String Adds custom classes to icon element <MDBAutocompleteV5 icon="envelope" iconClass="customClass" />
iconLight Boolean false Use this property to set light icon (fal) <MDBAutocompleteV5 icon="twitter" iconLight />
iconRegular Boolean false Use this property to set regular icon (far) <MDBAutocompleteV5 icon="twitter" iconRegular />
iconSize String Sets icon size <MDBAutocompleteV5 icon="pencil-alt" size="5x" />
noSuggestion Array of one element ['No options'] Set custom no suggestion option <MDBAutocompleteV5 noSuggestion={['Your text']} />
highlightClasses String false Set custom highlight classes to elements in the list <MDBAutocompleteV5 highlightClasses="customHighlightClass" />
id String Sets component ID <MDBAutocompleteV5 id="myId" />
label String Sets label for Autocomplete input <MDBAutocompleteV5 label="Choose your favorite state" />
labelClass String Adds custom classes to label <MDBAutocompleteV5 labelClass="myClass" />
labelStyles String Adds custom classes to label <MDBAutocompleteV5 labelStyles={display: 'block'} />
placeholder String Adds placeholder text <MDBAutocompleteV5 placeholder="Choose your favorite state" />
valueDefault String Sets default value of the autocomplete input <MDBAutocompleteV5 valueDefault="Default" />
visibleOptions Number or String 5 Sets number of visible elements in the list <MDBAutocompleteV5 visibleOptions={5} />

API Reference: Autocomplete Methods

Name Description Example
getValue Returns input value on onChange event <MDBAutocomplete getValue={this.logValue} />

Vue Bootstrap Autocomplete

Vue Autocomplete - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap Autocomplete is a component which predicts the words basing on the first few letters given by a user, while one is typing it. It takes in an Array full of suggestions.

Since MDB Vue 6.2.0 you can use the v-model directive for two-way data binding in the mdbAutocomplete component

Vue live preview

Basic example MDB Pro component

The filter property is required in order for component to work properly. The option accepts a function that is expected to return an array of results or a Promise that resolves to an array of results.

        
            
          <template>
            <mdb-autocomplete :data="states" label="What is your favorite US state?" v-model="state" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbAutocomplete
            } from "mdbvue";
            export default {
              name: "AutocompletePage",
              components: {
                mdbAutocomplete
              },
              data() {
                return {
                  state: "",
                  states: [
                    "Alabama",
                    "Alaska",
                    "Arizona",
                    "Arkansas",
                    "California",
                    "Colorado",
                    "Connecticut",
                    "Delaware",
                    "Florida",
                    "Georgia",
                    "Hawaii",
                    "Idaho",
                    "Illnois",
                    "Indiana",
                    "Iowa",
                    "Kansas",
                    "Kentucky",
                    "Louisiana",
                    "Maine",
                    "Maryland",
                    "Massachusetts",
                    "Michigan",
                    "Minnesota",
                    "Mississippi",
                    "Missouri",
                    "Montana",
                    "Nebraska",
                    "Nevada",
                    "New Hampshire",
                    "New Jersey",
                    "New Mexico",
                    "New York",
                    "North Carolina",
                    "North Dakota",
                    "Ohio",
                    "Oklahoma",
                    "Oregon",
                    "Pennsylvania",
                    "Rhode Island",
                    "South Carolina",
                    "South Dakota",
                    "Tennessee",
                    "Texas",
                    "Utah",
                    "Vermont",
                    "Virginia",
                    "Washington",
                    "West Virginia",
                    "Wisconsin",
                    "Wyoming"
                  ]
                };
              }
            };
          </script>
          
        
    

Outline MDB Pro component

Set outline on autocomplete with following code.

        
            
          <template>
            <mdb-autocomplete outline :data="states" label="What is your favorite US state?" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbAutocomplete
            } from "mdbvue";
            export default {
              name: "AutocompletePage",
              components: {
                mdbAutocomplete
              },
              data() {
                return {
                  states: [
                    "Alabama",
                    "Alaska",
                    "Arizona",
                    "Arkansas",
                    "California",
                    "Colorado",
                    "Connecticut",
                    "Delaware",
                    "Florida",
                    "Georgia",
                    "Hawaii",
                    "Idaho",
                    "Illnois",
                    "Indiana",
                    "Iowa",
                    "Kansas",
                    "Kentucky",
                    "Louisiana",
                    "Maine",
                    "Maryland",
                    "Massachusetts",
                    "Michigan",
                    "Minnesota",
                    "Mississippi",
                    "Missouri",
                    "Montana",
                    "Nebraska",
                    "Nevada",
                    "New Hampshire",
                    "New Jersey",
                    "New Mexico",
                    "New York",
                    "North Carolina",
                    "North Dakota",
                    "Ohio",
                    "Oklahoma",
                    "Oregon",
                    "Pennsylvania",
                    "Rhode Island",
                    "South Carolina",
                    "South Dakota",
                    "Tennessee",
                    "Texas",
                    "Utah",
                    "Vermont",
                    "Virginia",
                    "Washington",
                    "West Virginia",
                    "Wisconsin",
                    "Wyoming"
                  ]
                };
              }
            };
          </script>
          
        
    

Customization

You can customize the autocomplete's appearance by using adding custom icons, managing the number of options visible in the scrollable dropdown or disabling scrolling behaviour. Take a look at the API tab to explore all of the possible options.

        
            
        <template>
          <mdb-autocomplete icon="paper-plane" far :display="6" :data="states" placeholder="..." label="..." />
        </template>
        
        
    

Custom filter function

You can overwrite the filtering logic with the filterFunction property.

        
            
        <template>
          <mdb-autocomplete outline :data="states" label="Select your state" :filterFunction="filterResults" />
        </template>
        
        
    
        
            
        <script>
          import {
            mdbAutocomplete
          } from "mdbvue";
          export default {
            name: "AutocompletePage",
            components: {
              mdbAutocomplete
            },
            data() {
              return {
                states: [
                  "Alabama",
                  "Alaska",
                  "Arizona",
                  "Arkansas",
                  "California",
                  "Colorado",
                  "Connecticut",
                  "Delaware",
                  "Florida",
                  "Georgia",
                  "Hawaii",
                  "Idaho",
                  "Illnois",
                  "Indiana",
                  "Iowa",
                  "Kansas",
                  "Kentucky",
                  "Louisiana",
                  "Maine",
                  "Maryland",
                  "Massachusetts",
                  "Michigan",
                  "Minnesota",
                  "Mississippi",
                  "Missouri",
                  "Montana",
                  "Nebraska",
                  "Nevada",
                  "New Hampshire",
                  "New Jersey",
                  "New Mexico",
                  "New York",
                  "North Carolina",
                  "North Dakota",
                  "Ohio",
                  "Oklahoma",
                  "Oregon",
                  "Pennsylvania",
                  "Rhode Island",
                  "South Carolina",
                  "South Dakota",
                  "Tennessee",
                  "Texas",
                  "Utah",
                  "Vermont",
                  "Virginia",
                  "Washington",
                  "West Virginia",
                  "Wisconsin",
                  "Wyoming"
                ]
              };
            },
            methods: {
              filterResults(item, search) {
                return item.toLowerCase().indexOf(search.toLowerCase()) === 0;
              }
            }
          };
        </script>
        
        
    

Async example

To fetch data asynchronously, add the isAsycs property to your component - it will provide a watcher for changes and display a message (which you can customize using the loadingText prop) while component awaits data.

        
            
        <template>
          <mdb-autocomplete @search="requestCountry" :data="countryList" :filterFunction="item => item"
            label="Select your country" :isAsync="true" />
        </template>
        
        
    
        
            
        <script>
          import {
            mdbAutocomplete
          } from "mdbvue";
          export default {
            name: "AutocompletePage",
            components: {
              mdbAutocomplete
            },
            data() {
              return {
                countryList: []
              };
            },
            methods: {
              requestCountry(value) {
                if (value === "") {
                  this.countryList = [];
                  return;
                }
                axios
                  .get(`https://restcountries.eu/rest/v2/name/${value}`)
                  .then(response => {
                    this.countryList = response.data.map(
                      country => country.name
                    );
                  })
                  .catch(err => {
                    console.log(err);
                    this.countryList = [];
                  });
              }
            }
          };
        </script>
        
        
    

Autocomplete within form MDB Pro component

Autocomplete can be used inside the form to make it easier for users to enter data.

Sign up

or Sign up with:

        
            
        <template>
          <mdb-card>
            <mdb-card-body class="mx-4">
              <div class="text-center">
                <h3 class="dark-grey-text mb-5"><strong>Sign up</strong></h3>
              </div>
              <mdb-input label="Your email" type="email" />
              <mdb-input label="Your password" type="password" containerClass="mb-0" />
              <mdb-autocomplete :data="countries" label="Your country" class="pb-3" />
              <div class="text-center mb-3">
                <mdb-btn type="button" gradient="blue" rounded class="btn-block z-depth-1a">Sign up</mdb-btn>
              </div>
              <p class="font-small dark-grey-text text-right d-flex justify-content-center mb-3 pt-2">
                or Sign up with:
              </p>
              <div class="row my-3 d-flex justify-content-center">
                <mdb-btn type="button" color="white" rounded class="mr-md-3 z-depth-1a">
                  <mdb-icon fab icon="facebook" class="blue-text text-center" />
                </mdb-btn>
                <mdb-btn type="button" color="white" rounded class="mr-md-3 z-depth-1a">
                  <mdb-icon fab icon="twitter" class="blue-text" />
                </mdb-btn>
                <mdb-btn type="button" color="white" rounded class="z-depth-1a">
                  <mdb-icon fab icon="google-plus" class="blue-text" />
                </mdb-btn>
              </div>
            </mdb-card-body>
            <mdb-modal-footer class="mx-5 pt-3 mb-1">
              <p class="font-small grey-text d-flex justify-content-end">
                Not a member? <a href="#" class="blue-text ml-1"> Sign In</a>
              </p>
            </mdb-modal-footer>
          </mdb-card>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbAutocomplete,
            mdbInput,
            mdbBtn,
            mdbCard,
            mdbCardBody,
            mdbModalFooter,
            mdbIcon
          } from "mdbvue";
          export default {
            name: "AutocompletePage",
            components: {
              mdbAutocomplete,
              mdbInput,
              mdbBtn,
              mdbCard,
              mdbCardBody,
              mdbModalFooter,
              mdbIcon
            },
            data() {
              return {
                countries: [
                  "Afghanistan",
                  "Albania",
                  "Algeria",
                  "Andorra",
                  "Angola",
                  "Antigua and Barbuda",
                  "Argentina",
                  "Armenia",
                  "Australia",
                  "Austria",
                  "Azerbaijan",
                  "Bahamas",
                  "Bahrain",
                  "Bangladesh",
                  "Barbados",
                  "Belarus",
                  "Belgium",
                  "Belize",
                  "Benin",
                  "Bhutan",
                  "Bolivia",
                  "Bosnia and Herzegovina",
                  "Botswana",
                  "Brazil",
                  "Brunei",
                  "Bulgaria",
                  "Burkina Faso",
                  "Burundi",
                  "Cabo Verde",
                  "Cambodia",
                  "Cameroon",
                  "Canada",
                  "Central African Republic (CAR)",
                  "Chad",
                  "Chile",
                  "China",
                  "Colombia",
                  "Comoros",
                  "Costa Rica",
                  "Cote d'Ivoire",
                  "Croatia",
                  "Cuba",
                  "Cyprus",
                  "Czech Republic",
                  "Denmark",
                  "Djibouti",
                  "Dominica",
                  "Dominican Republic",
                  "Ecuador",
                  "Egypt",
                  "El Salvador",
                  "Equatorial Guinea",
                  "Eritrea",
                  "Estonia",
                  "Ethiopia",
                  "Fiji",
                  "Finland",
                  "France",
                  "Gabon",
                  "Gambia",
                  "Georgia",
                  "Germany",
                  "Ghana",
                  "Greece",
                  "Grenada",
                  "Guatemala",
                  "Guinea",
                  "Guinea-Bissau",
                  "Guyana",
                  "Haiti",
                  "Honduras",
                  "Hungary",
                  "Iceland",
                  "India",
                  "Indonesia",
                  "Iran",
                  "Iraq",
                  "Ireland",
                  "Israel",
                  "Italy",
                  "Jamaica",
                  "Japan",
                  "Jordan",
                  "Kazakhstan",
                  "Kenya",
                  "Kiribati",
                  "Kosovo",
                  "Kuwait",
                  "Kyrgyzstan",
                  "Laos",
                  "Latvia",
                  "Lebanon",
                  "Lesotho",
                  "Liberia",
                  "Libya",
                  "Liechtenstein",
                  "Lithuania",
                  "Luxembourg",
                  "Macedonia (FYROM)",
                  "Madagascar",
                  "Malawi",
                  "Malaysia",
                  "Maldives",
                  "Mali",
                  "Malta",
                  "Marshall Islands",
                  "Mauritania",
                  "Mauritius",
                  "Mexico",
                  "Micronesia",
                  "Moldova",
                  "Monaco",
                  "Mongolia",
                  "Montenegro",
                  "Morocco",
                  "Mozambique",
                  "Myanmar (Burma)",
                  "Namibia",
                  "Nauru",
                  "Nepal",
                  "Netherlands",
                  "New Zealand",
                  "Nicaragua",
                  "Niger",
                  "Nigeria",
                  "North Korea",
                  "Norway",
                  "Oman",
                  "Pakistan",
                  "Palau",
                  "Palestine",
                  "Panama",
                  "Papua New Guinea",
                  "Paraguay",
                  "Peru",
                  "Philippines",
                  "Poland",
                  "Portugal",
                  "Qatar",
                  "Romania",
                  "Russia",
                  "Rwanda",
                  "Saint Kitts and Nevis",
                  "Saint Lucia",
                  "Saint Vincent and the Grenadines",
                  "Samoa",
                  "San Marino",
                  "Sao Tome and Principe",
                  "Saudi Arabia",
                  "Senegal",
                  "Serbia",
                  "Seychelles",
                  "Sierra Leone",
                  "Singapore",
                  "Slovakia",
                  "Slovenia",
                  "Solomon Islands",
                  "Somalia",
                  "South Africa",
                  "South Korea",
                  "South Sudan",
                  "Spain",
                  "Sri Lanka",
                  "Sudan",
                  "Suriname",
                  "Swaziland",
                  "Sweden",
                  "Switzerland",
                  "Syria",
                  "Taiwan",
                  "Tajikistan",
                  "Tanzania",
                  "Thailand",
                  "Timor-Leste",
                  "Togo",
                  "Tonga",
                  "Trinidad and Tobago",
                  "Tunisia",
                  "Turkey",
                  "Turkmenistan",
                  "Tuvalu",
                  "Uganda",
                  "Ukraine",
                  "United Arab Emirates (UAE)",
                  "United Kingdom (UK)",
                  "United States of America (USA)",
                  "Uruguay",
                  "Uzbekistan",
                  "Vanuatu",
                  "Vatican City (Holy See)",
                  "Venezuela",
                  "Vietnam",
                  "Yemen",
                  "Zambia",
                  "Zimbabwe"
                ]
              };
            }
          };
        </script>
        
        
    
        
            
          <style scoped>
            .font-small {
              font-size: 0.8rem;
            }
          </style>
          
        
    

Autocomplete - API

In this section you will find advanced information about the Autocomplete component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

        
            
    <script>
      import {
        mdbAutocomplete
      } from 'mdbvue';
    </script>
    
        
    

API Reference: Properties

Name Type Default Description Example
data Array [] Array of all available options (string) <mdb-autocomplete :data="['option 1', 'option 2']" ... />
isAsync Boolean false Component will display loading information until data is fetched <mdb-autocomplete isAsync ... />
showAll Boolean false If set to true, the component will display all options on empty search <mdb-autocomplete showAll ... />
label String Add description to the component label <mdb-autocomplete label="Example label" ... />
placeholder String Add content to the component placeholder <mdb-autocomplete placeholder="Example placeholder" ... />
icon String Adds icon on the left site of the input <mdb-autocomplete icon="envelope" ... />
iconClass String Adds custom class to the icon <mdb-autocomplete icon="envelope" iconClass="yellow-text" ... />
far Boolean false Sets icon's style to regular <mdb-autocomplete far ... />
regular Boolean false Sets icon's style to regular <mdb-autocomplete regular ... />
fal Boolean false Sets icon's style to light <mdb-autocomplete fal ... />
light Boolean false Sets icon's style to light <mdb-autocomplete light ... />
fab Boolean false Sets icon's style to brands <mdb-autocomplete fab ... />
brands Boolean false Sets icon's style to brands <mdb-autocomplete brands ... />
fad Boolean false Sets icon's style to duotone <mdb-autocomplete fad ... />
duotone Boolean false Sets icon's style to duotone <mdb-autocomplete duotone ... />
outline Boolean false Changes component's style to outline <mdb-autocomplete outline ... />
bg Boolean false Sets design to animated border with background <mdb-autocomplete bg ... />
loadingText String 'Loading results...' Message displayed while the component with isAsync value is awaiting data <mdb-autocomplete isAsync loadingText="..." />
resultText String 'no results found' Message displayed when no matching results are found <mdb-autocomplete resultText="..." />
scroll Boolean true Makes dropdown scrollable with fixed maximum height <mdb-autocomplete :scroll="false" />
display Number 4 Maximum number of options displayed at once in the scrollable container <mdb-autocomplete :display="5" />
flipOnScroll Boolean true Enables flipping dropdown on scroll events <mdb-autocomplete :flipOnScroll="false" />
disabled Boolean false Disables autocomple input <mdb-autocomplete disabled />
clearBtn Boolean true Toggles the visibility of the clear button <mdb-autocomplete :clearBtn="false" />
filterFunction Function (item, search) => item.toLowerCase().indexOf(search.toLowerCase()) > -1 Functions takes two arguments - the data element and the search value and return Boolean value <mdb-autocomplete :filterFunction="filterFunction" />
validation Boolean false Setting this property to true will add required property to the nested input field <mdb-autocomplete validation />
wasValidated Boolean false Setting this property to true will add validated styling to the component <mdb-autocomplete validation wasValidated />
validFeedback [String, Boolean] false Valid feedback label <mdb-input validFeedback="Correct" ... />
invalidFeedback [String, Boolean] false Invalid feedback label <mdb-input :invalidFeedback="Incorrect" ... />
top Boolean false Opens the dropdown on the top by default <mdb-autocomplete top />
apoBodypendT Boolean false Appends the autocomplete's dropdown to the end of the document <mdb-autocomplete append-to-body />

API Reference: Events & directives

Name Description Example
v-model Allows for two way data binding <mdb-autocomplete v-model="option" />
@search Emits searched value <mdb-autocomplete @search="handleSearch" />
@focus Emitted on input's native focus event, meaning when the field gains focus. <mdb-autocomplete @focus="onFocus" />
@blur Emitted on input's native blur event, meaning when the field looses focus. <mdb-autocomplete @blur="onBlur" />
@clear Emitted when user clicks the x button <mdb-autocomplete @clear="clear" />